from operator import xor
import os
import struct

base = "c:\\Program Files\\Armadillo Run\\Levels"
files=[
#    "short.test"
    "Tutorial 1 - Introduction.lvl",
    "Empty.lvl",
    "empty-armadillo.lvl",
    "empty-toolflags.lvl",
    "empty-metal.lvl",
    "empty-metal-bar-join.lvl",
    "empty-top.lvl",
    "empty-left.lvl",
    "empty-15bars.lvl",
    "empty-20-bars.lvl",
    "Chaos Generator.lvl",
    "Extra 8 - A tricky ascent.lvl",
    "Level 50 - Swing 2.lvl",
    "Level 50 - Swing 2.22.lvl",
    "Level 50 - Swing 2.end",
    "rocket ship.lvl",
    "Tutorial 5 - Cloth.lvl",
    "Tutorial 9 - Rockets.lvl"
]

files = [
    "Empty.lvl",
    "empty-toolflags.lvl",
    "empty-box.lvl",
    "empty-metal.lvl",
    "empty-metal-bar-join.lvl",
]


for file in files:
    headerSkip=8
    f = open(os.path.join(base,file),"rb")
    f.seek(-4,2)
    rawSize = f.tell()
    checksumData = f.read(4)
    (checksum,)=struct.unpack("I",checksumData)

    f.seek(4,0)
    (features,)=struct.unpack("I",f.read(4))
#    if features == 3:
#        size = (rawSize-headerSkip)-tailskip
#    else:
    size = (rawSize-headerSkip)

    f.seek(headerSkip,0)
    xorCheck = 0
    print "size=%d, size/4=%d,size/4*4=%d"%(size,size/4,size/4*4)
    for i in range(0,size/4):
        data = f.read(4)
        unpackedData = struct.unpack("I",data)[0]
        #print "0x%08X"%(unpackedData)
        xorCheck = xor(xorCheck,unpackedData)
    if (size/4*4) < size:
        extraDataSize = size-(size/4*4)
        #print "extraDataSize=%d"%(extraDataSize)
        data = f.read(extraDataSize)
        for i in range(0,4-len(data)):
            data=data+chr(0)
        #print "data=[0x%02X,0x%02X,0x%02X,0x%02X]"%struct.unpack("4B",data)
        unpackedData = struct.unpack("I",data)[0]
        #print "0x%08X"%(unpackedData)
        xorCheck = xor(xorCheck,unpackedData)
        
    f.seek(-4,2)        
    print "%s stored=0x%08X xorCheck=0x%08X(0x%08X)"%(file,checksum,xorCheck,xor(checksum,xorCheck))
    f.close()
    